//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void setSocketNonblocking(int socket) {
	int save_fd;
	save_fd = fcntl(socket, F_GETFL);
	save_fd |= O_NONBLOCK;
	fcntl(socket, F_SETFL, save_fd);
}

int mastersocket, addrlen;
struct sockaddr_in masteraddress;
int socketsStartup(char* vbind,int port) {
	addrlen = sizeof (struct sockaddr_in);
	const int lclyes = 1;
	memset(&masteraddress, 0, sizeof(struct sockaddr_in));
	printf("%s Initialising internet connection...\n",startupprefix);
	if ((mastersocket = socket(AF_INET, SOCK_STREAM, 0)) > 0) {
		printf ("%s    > Socket opened\n",startupprefixsub);
	}else{
		printf("%s    > Was not able to get a socket!\n",startupprefixsub);
		return -1;
	}
	masteraddress.sin_family = AF_INET;
	if (!inet_aton(vbind, &masteraddress.sin_addr)) {
		printf("%s    > Setting socket address to %s failed.\n",startupprefixsub,vbind);
		return -1;
	}
	masteraddress.sin_port = htons (port);
	setsockopt(mastersocket, SOL_SOCKET,SO_REUSEADDR, &lclyes, sizeof(int));
	if (bind(mastersocket,(struct sockaddr *) &masteraddress,sizeof (masteraddress)) == 0) {
		printf("%s    > Binding to %s successful.\n",startupprefixsub,vbind);
	}else{
		printf("%s    > Binding to %s failed! Terminating.\n",startupprefixsub,vbind);return;
	}
	listen (mastersocket, 6667);
}
void checkNewClients() {
	int new_socket;
	new_socket = accept(mastersocket,(struct sockaddr *) &masteraddress,&addrlen);
	if (new_socket > 0) {
		setSocketNonblocking(new_socket);
		userAdd(new_socket);
	}
}
int sendOnSocket(int userid,const unsigned char* buffer,int buffsize) {
	int sock = uSocket(userid);
	int retval = send(sock,buffer,buffsize,MSG_NOSIGNAL);
	if (retval > 0) {
		return retval;
	}else{
		if (errno != EWOULDBLOCK && errno != EINTR) {
			close(sock);
			userQuit(userid,USERQUIT_EOF);
			return 0;
		}
	}
}

